<template>
  <el-form
    ref='changeForm'
    :model='changeForm'
    :rules='changeRules'
    class='register-form'
  >
    <el-row>
      <el-form-item prop='email'>
        <!-- style='padding-right: 5%' -->
        <el-input
          v-model='changeForm.email'
          type='text'
          auto-complete='off'
          placeholder='请输入注册的邮箱'
        >
          <svg-icon
            slot='prefix'
            icon-class='email'
            class='el-input__icon input-icon'
          />
        </el-input>
      </el-form-item>
    </el-row>
    <el-row>
      <el-form-item prop='password'>
        <el-input
          v-model='changeForm.password'
              type='password'
              auto-complete='off'
              placeholder='原密码'
            >
              <svg-icon
                slot='prefix'
                icon-class='password'
                class='el-input__icon input-icon'
              />
            </el-input>
          </el-form-item>
        </el-row>
        <el-row>
          <el-form-item prop='new_password'>
            <el-input
              v-model='changeForm.new_password'
              type='password'
              auto-complete='off'
              placeholder='新密码'
            >
              <svg-icon
                slot='prefix'
                icon-class='password'
                class='el-input__icon input-icon'
              />
            </el-input>
          </el-form-item>
        </el-row>
        <el-row>
          <el-form-item prop='new_password_again'>
            <el-input
              v-model='changeForm.new_password_again'
              type='password'
              auto-complete='off'
              placeholder='再次输入新密码'
            >
              <svg-icon
                slot='prefix'
                icon-class='password'
                class='el-input__icon input-icon'
              />
            </el-input>
          </el-form-item>
        </el-row>
      </el-form>
</template>

<script>
export default {
  data() {
    // 密码强度限制
    var passwordConfirm = (rule, value, callback) => {
      if (value) {
        var pass_flag =
          /[A-Z]/.test(value) && /[a-z]/.test(value) && /[0-9]/.test(value);
        if (pass_flag == false) {
          callback(new Error('密码需要包含大写字母、小写字母、数字'));
        }
        callback();
      }
      callback(new Error('密码不能为空'));
    };
    return {
      loginForm: {
        email: '',
        password: '',
      },
      loginRules: {
        email: [
          { required: true, trigger: 'blur', message: '邮箱不能为空' },
          {
            pattern: /^[a-zA-Z0-9]+@tongji.edu.cn$/,
            message: '请输入合法的同济邮箱',
            trigger: 'change',
          },
        ],
        password: [
          { required: true, trigger: 'blur', message: '密码不能为空' },
        ],
        code: [
          { required: true, trigger: 'change', message: '验证码不能为空' },
        ],
      },
      forgetForm: {
        new_password: '',
        email: '',
        code: '',
      },
      forgetRules: {
        email: [
          { required: true, trigger: 'blur', message: '邮箱不能为空' },
          {
            pattern: /^[a-zA-Z0-9]+@tongji.edu.cn$/,
            message: '请输入合法的同济邮箱',
            trigger: 'change',
          },
        ],
        new_password: [
          { required: true, trigger: 'blur', message: '密码不能为空' },
          { validator: passwordConfirm, trigger: 'change' },
        ],
        code: [
          { required: true, trigger: 'change', message: '验证码不能为空' },
        ],
      },
      changeForm: {
        email: '',
        password: '',
        new_password: '',
        new_password_again: '',
      },
      changeRules: {
        email: [
          { required: true, trigger: 'blur', message: '邮箱不能为空' },
          {
            pattern: /^[a-zA-Z0-9]+@tongji.edu.cn$/,
            message: '请输入合法的同济邮箱',
            trigger: 'change',
          },
        ],
        password: [
          { required: true, trigger: 'blur', message: '密码不能为空' },
        ],
        new_password: [
          { required: true, trigger: 'blur', message: '密码不能为空' },
          { validator: passwordConfirm, trigger: 'blur' },
        ],
      },
      loading: false,
      passwordDialogVisible: false,
      changePasswordDialogVisible: false,
    };
  },
  mounted() {
    //判断登录
    //let userInfo = JSON.parse(localStorage.getItem('userInfo'));
    //无 则返回
    //if (null === userInfo) return;
    //否则 查看登录状态
    //// console.log('userInfo', userInfo.isLogin);
    //if (userInfo.isLogin) {
    //  this.name = userInfo.name;
    //   if (userInfo.manage) {
    //     this.manage = true;//显示管理员登录信息
    //   } else {
    //     this.user = true;//显示普通用户登录信息
    //   }
    //}
  },
  methods: {
    login() {
      // 前端检查邮箱
      var reg = /^[a-zA-Z0-9]+@tongji.edu.cn$/;
      var email_flag = reg.test(this.loginForm.email);
      if (email_flag == false) {
        this.$message({
          message: '邮件格式错误，请重新输入！',
          type: 'error',
        });
        return;
      }
      // 前端密码强度
      var pass_flag =
        /[A-Z]/.test(this.loginForm.password) &&
        /[a-z]/.test(this.loginForm.password) &&
        /[0-9]/.test(this.loginForm.password);
      if (pass_flag == false) {
        this.$message({
          message: '密码错误，请重试！',
          type: 'error',
        });
        return;
      }
      // 调用api登录，交互
      this.$axios({
        url: '/api/login/user',
        params: {
          email: this.loginForm.email,
          password: this.loginForm.password,
        },
        method: 'get',
      })
        // 成功
        .then((result) => {
          // 登录成功
          if (result.data.code == 200) {
            this.$store.commit('setToken', result.data.token);
            this.$message({
              message: '登录成功！',
              type: 'success',
            });
            // 保存登录用户信息
            this.$store.commit('setEmail', this.loginForm.email);
            this.$store.commit('setUsername', result.data.username);
            this.$store.commit('setRole', result.data.role);
            this.$store.commit('setAvatar', result.data.avatar);
            // 跳转页面到主页
            this.$router.push('/search');
          } else if (result.data.code == 400) {
            // 密码错误
            this.$message({
              message: '密码错误，请重试！',
              type: 'error',
            });
          } else if (result.data.code == 404) {
            // 用户不存在
            this.$message({
              message: '用户不存在，请重试！',
              type: 'error',
            });
          } else if (result.data.code == 500) {
            // 服务器错误
            this.$message({
              message: '服务器错误',
              type: 'error',
            });
          } else {
            // console.log(result.data);
          }
          // console.log(result.data);
          // console.log(result.data.msg);
        })
        // 调用失败
        .catch(function (error) {
          // console.log(error);
        });
    },

    // 忘记密码对话框
    to_forget() {
      this.forgetForm = {
        new_password: '',
        email: '',
        code: '',
      };
      this.passwordDialogVisible = true;
    },
    // 修改密码对话框
    to_change() {
      this.changeForm = {
        new_password: '',
        email: '',
        code: '',
      };
      this.changePasswordDialogVisible = true;
    },
    // 发送验证邮件
    send_code() {
      // 前端验证同济邮箱
      var reg = /^[a-zA-Z0-9]+@tongji.edu.cn$/;
      var email_flag = reg.test(this.forgetForm.email);
      if (email_flag == false) {
        this.$message({
          message: '邮件格式错误，请重新输入！',
          type: 'error',
        });
        return;
      }

      // 前后端交互
      // 发送邮件
      this.$axios({
        url: '/api/auth/forget-emailcode',
        data: {
          email: this.forgetForm.email,
        },
        method: 'post',
      })
        // 成功
        .then((result) => {
          //发送邮件成功
          if (result.data.code == 200) {
            this.$message({
              message: '邮件已发送，请查收！',
              type: 'success',
            });
            // // console.log(result.data);
          } else if (result.data.code == 400) {
            // 无效的邮箱格式/用户已存在
            this.$message({
              message: result.data.msg,
              type: 'error',
            });
          } else if (result.data.code == 500) {
            // 服务器错误
            this.$message({
              message: '服务器错误',
              type: 'error',
            });
          } else {
            // console.log(result.data);
          }
          // console.log(result.data);
          // console.log(result.data.msg);
        })
        // 调用失败
        .catch(function (error) {
          // console.log(error);
        });
    },

    // 验证码确认
    confirm() {
      // 前端密码强度
      var pass_flag =
        /[A-Z]/.test(this.forgetForm.new_password) &&
        /[a-z]/.test(this.forgetForm.new_password) &&
        /[0-9]/.test(this.forgetForm.new_password);
      if (pass_flag == false) {
        this.$message({
          message: '密码需要包含大写字母、小写字母、数字！',
          type: 'error',
        });
        return;
      }
      // 比较验证码
      this.$axios({
        url: '/api/auth/check-emailcode',
        params: {
          email: this.forgetForm.email,
          emailcode: this.forgetForm.code,
        },
        method: 'get',
      })
        // 成功
        .then((result) => {
          // 验证成功
          if (result.data.code == 200) {
            // 调用修改密码的api
            // balabala
            this.$axios({
              url: '/api/auth/resest-password',
              data: {
                email: this.forgetForm.email,
                password: this.forgetForm.new_password,
              },
              method: 'post',
            })
              // 成功
              .then((result) => {
                // 修改成功
                if (result.data.code == 200) {
                  // 提示成功
                  this.$message.success('修改成功，请登录！');
                  // // console.log('修改成功，请登录！');
                  this.passwordDialogVisible = false;
                  // 重置表单
                  // 重新设置请求参数实体属性
                  this.forgetForm = {
                    new_password: '',
                    email: '',
                    code: '',
                  };
                } else if (result.data.code == 404) {
                  // 用户不存在
                  this.$message({
                    message: '修改失败，邮箱未注册请重试',
                    type: 'error',
                  });
                  return;
                } else if (result.data.code == 400) {
                  // 密码强度
                  this.$message({
                    message: '密码强度不符合要求请重试',
                    type: 'error',
                  });
                  return;
                } else {
                  // console.log(result.data);
                  return;
                }
              })
              // 调用失败
              .catch(function (error) {
                // console.log(error);
              });
            // 提示成功
          } else if (result.data.code == 400) {
            // 验证码错误
            this.$message({
              message: '验证码错误，请重试',
              type: 'error',
            });
          } else if (result.data.code == 500) {
            // 验证码过期
            this.$message({
              message: '验证码过期，请重新发送',
              type: 'error',
            });
          } else {
            // console.log(result.data);
          }
        })
        // 调用失败
        .catch(function (error) {
          // console.log(error);
        });
    },
    // 修改密码
    change_password() {
      // 重复密码
      if (this.changeForm.new_password_again != this.changeForm.new_password) {
        this.$message({
          message: '两次密码不一致，请重新输入',
          type: 'error',
        });
        return;
      }
      // 前端检查邮箱
      var reg = /^[a-zA-Z0-9]+@tongji.edu.cn$/;
      var email_flag = reg.test(this.changeForm.email);
      if (email_flag == false) {
        this.$message({
          message: '邮件格式错误，请重新输入！',
          type: 'error',
        });
        return;
      }
      // 前端密码强度
      var pass_flag =
        /[A-Z]/.test(this.changeForm.new_password) &&
        /[a-z]/.test(this.changeForm.new_password) &&
        /[0-9]/.test(this.changeForm.new_password);
      if (pass_flag == false) {
        this.$message({
          message: '新密码强度不符合要求！',
          type: 'error',
        });
        return;
      }

      //调用api修改密码
      this.$axios({
        url: '/api/auth/change-password',
        data: {
          email: this.changeForm.email,
          password: this.changeForm.password,
          new_password: this.changeForm.new_password,
        },
        method: 'post',
      })
        // 成功
        .then((result) => {
          // 修改成功
          if (result.data.code == 200) {
            this.$message({
              message: '密码修改成功！',
              type: 'success',
            });
            this.changeForm = {
              email: '',
              password: '',
              new_password: '',
              new_password_again: '',
            };
            this.changePasswordDialogVisible = false;
          } else if (result.data.code == 400) {
            // 原密码错误
            this.$message({
              message: '原密码错误,修改失败！',
              type: 'error',
            });
          } else if (result.data.code == 404) {
            // 邮箱未注册
            this.$message({
              message: '邮箱未注册',
              type: 'error',
            });
          } else if (result.data.code == 500) {
            // 服务器错误
            this.$message({
              message: '服务器错误',
              type: 'error',
            });
          } else {
            // console.log(result.data);
          }
        })
        // 调用失败
        .catch(function (error) {
          // console.log(error);
        });
    },
  },
  created() {},
};
</script>

<style lang='scss'>
.register-wrapper {
  width: 90%;
  height: 100%;
  background-color: rgba(255, 255, 255, 0);
  margin: 0 auto;
  margin-top: 5%;
  padding: 5%;
}

.register-form {
  margin: 0px auto;
  width: 100%;
  height: 100%;
  //padding: 2% 0;
  background: #ffffff00;
  justify-content: center;
  align-items: center;
}
.btn-register {
  display: inline-block;
  line-height: 1;
  white-space: nowrap;
  background-image: linear-gradient(
    90deg,
    rgb(114, 135, 254),
    rgb(130, 88, 186)
  );
  // background: rgb(175, 37, 37);
  border: 1px solid rgb(114, 135, 254);
  color: #ffffff;
  width: 100%;
  text-align: center;
  box-sizing: border-box;
  outline: 0;
  margin: 0;
  -webkit-box-sizing: border-box;
  -webkit-appearance: none;
  -webkit-transition: 0.1s;
  transition: 0.1s;
  font-weight: 500;
  padding: 12px 20px;
  font-size: 14px;
  border-radius: 4px;
}

.btn-register:focus,
.btn-register:hover {
  color: #ffffff;
  border-color: rgb(131, 150, 254);
  background-image: linear-gradient(
    90deg,
    rgb(131, 150, 254),
    rgb(158, 121, 205)
  );
}
.btn-register:active {
  color: #ffffff;
  border-color: rgb(114, 135, 250);
  background-image: linear-gradient(
    90deg,
    rgb(114, 135, 250),
    rgb(106, 62, 164)
  );
  outline: 0;
}
</style>